local FSA_PlayerRanks = {}
function FSA_GetPlayerRanks()
	return FSA_PlayerRanks
end

local function FSA_SaveRank( ply )
	local plysteamid = ply:SteamID()
	local plyfsalevel = ply:FSA_Level()
	local result = sql.QueryValue( "SELECT rank FROM fsa_playerinfo WHERE steamid = '" .. plysteamid .. "'" )
	if result then
		sql.Query( "UPDATE fsa_playerinfo SET rank = " .. plyfsalevel .. " WHERE steamid = '" .. plysteamid .. "'" )
	else
		sql.Query( "INSERT INTO fsa_playerinfo (`steamid`, `rank`, `bantime`) VALUES ('" .. plysteamid .. "', '" .. plyfsalevel .. "', '-1')" )
	end	
end

local function FSA_LoadRanks()
	if sql.TableExists( "fsa_playerinfo" ) then
		Msg("[FSA][SV] Table \"fsa_playerinfo\" exsists.\n")
	else
		Msg("[FSA][SV] Table \"fsa_playerinfo\" does not exsist, creating.\n")
		local errors = sql.Query( "CREATE TABLE fsa_playerinfo ( steamid varchar(40), rank int, bantime long )" )
		if sql.TableExists( "fsa_playerinfo" ) then
			Msg("[FSA][SV] Table \"fsa_playerinfo\" created.\n")
		else
			Msg("[FSA][SV] Table \"fsa_playerinfo\" not created.\n")
			Msg("[FSA][SV] Table creation error: " .. sql.LastError( errors ) .. "\n")
			return
		end
	end
end
FSA_LoadRanks()

local function FSA_SetInitialRank( ply, plysteamid, plyuid )
	if SinglePlayer() or IsLocalHost() then
		FSA_SetRank( ply, 0, true )
	elseif !FSA_IsBanned( ply ) then
		local result = sql.QueryValue( "SELECT rank FROM fsa_playerinfo WHERE steamid = '" .. plysteamid .. "'" )
		if result then
			FSA_SetRank( ply, result, true )
		else
			FSA_SetRank( ply, 5 )
		end
	else
		FSA_SetRank( ply, 5 )
	end
end
hook.Add( "PlayerAuthed", "FSA_SetInitialRank", FSA_SetInitialRank )

local function FSA_Disconnect( ply ) --helps clean up the table :)
	local plysteamid = ply:SteamID()
	for steamid, v in ipairs( FSA_PlayerRanks ) do
        if plysteamid == steamid then
			table.remove( FSA_PlayerRanks, ply:UniqueID() )
			break
		end
    end
end
hook.Add( "PlayerDisconnected", "FSA_Disconnect", FSA_Disconnect )

function FSA_SetRank( ply, rank, loading )
	ply:SetNetworkedInt( "fsa_level", rank )
	Msg("[FSA][SV] Setting " .. ply:Nick() .. " to rank " .. rank .. ".\n")
	
	FSA_PlayerRanks[ply:UniqueID()] = tonumber(rank)
	if loading != true then
		FSA_SaveRank( ply )
	end
end

--Disguise Sutff
local function FSA_TriggerDisguise( ply, cmd, args )
	local plylevel = ply:GetNetworkedInt( "fsa_level", 5 )
	local plyid = ply:UniqueID()
	if plylevel <= 2 then
		ply:SetNetworkedInt( "fsa_level", 4 ) --vip
		Msg("[FSA][SV] Enabling disguise on " .. ply:Nick() .. ".\n")
	elseif plylevel == 4 then --4 = vip
		if FSA_PlayerRanks[plyid] then
			ply:SetNetworkedInt( "fsa_level", FSA_PlayerRanks[plyid] )
			Msg("[FSA][SV] Removing disguise on " .. ply:Nick() .. ".\n")
		end
	end
end
concommand.Add( "fsa_disguise", FSA_TriggerDisguise )

function FSA_AdminInDisguise( ply )
	if FSA_PlayerRanks[ply:UniqueID()] <= 2 then
		return true
	else
		return nil
	end
end
function FSA_SuperAdminInDisguise( ply )
	if FSA_PlayerRanks[ply:UniqueID()] <= 1 then
		return true
	else
		return nil
	end
end
function FSA_OwnerInDisguise( ply )
	if FSA_PlayerRanks[ply:UniqueID()] == 0 then
		return true
	else
		return nil
	end
end
--End Disguise Stuff

local function FSA_GiveOwner( ply, cmd, args )
	if !ply:IsConsole() then return end
	if !args[1] then return end
	local newowner = tonumber( args[1] )
	newowner = Player( newowner )
	if ValidEntity( newowner ) then
		FSA_SetRank( newowner, 0 )
	else
		Msg("[FSA][SV] Player Not Found")
	end
end
concommand.Add( "fsa_giveowner", FSA_GiveOwner )

local CONSOLE = FindMetaTable("Entity") --enables ownership giving via server console
function CONSOLE:IsConsole()
	if !ValidEntity( self ) then
		return true
	end
	return false
end
CONSOLE = nil

function IsLocalHost()
	if isDedicatedServer() then
		return false
	else
		return true
	end
end