Msg("\n-----------------\n[FSA][SV] Loading\n-----------------\n")
AddCSLuaFile("fsa_coreplugins.lua")
include("fsa_shared.lua")
AddCSLuaFile("fsa_shared.lua")
include("fsa_ranks.lua")
include("fsa_banning.lua")

local function FSA_AdminCommand( ply, cmd, args ) --args[1] = plugin name, args[2] = player uniqueid to affect
	if !ply:IsAdmin() then return end
	local affectplayer = FSA_plyByID( args[2] ) or nil
	for k, data in pairs(FSA_GetPlugins()) do
		if data.Name == args[1] then
			if data.MenuFunction == "" then
				data.RunFunction( null, ply )
				break
			elseif (affectplayer == ply and data.AllowSelf) or ply:FSA_CanAffect( affectplayer ) then
				data.RunFunction( affectplayer, ply )
				break
			end
		end
	end
end
concommand.Add( "fsa_cmd", FSA_AdminCommand )

local function FSA_AdminSubCommand( ply, cmd, args ) --args[1] = plugin name, args[2] = submenu number, args[3] = player uniqueid to affect
	if !ply:IsAdmin() then return end
	local affectplayer = FSA_plyByID( args[3] )
	for k, data in pairs(FSA_GetPlugins()) do
		if data.Name == args[1] then
			if (affectplayer == ply and data.AllowSelf) or ply:FSA_CanAffect(affectplayer) then
				local subfunc = tonumber(args[2])
				data.SubMenufunction[subfunc]( affectplayer, ply )
				break
			end
		end
	end
end
concommand.Add( "fsa_cmdsub", FSA_AdminSubCommand )

local function FSA_AdminSubSubCommand( ply, cmd, args )
	if !ply:IsAdmin() then return end
	args[4] = args[4] or ""
	local affectplayer = FSA_plyByID( args[3] )
	for k, data in pairs(FSA_GetPlugins()) do
		if data.Name == args[1] then
			if (affectplayer == ply and data.AllowSelf) or ply:FSA_CanAffect(affectplayer) then
				data.RunFunction( affectplayer, ply, {args[2], args[4]} )
				break
			end
		end
	end
end
concommand.Add( "fsa_cmdsubsub", FSA_AdminSubSubCommand )

local PLAYER = FindMetaTable("Player")
function PLAYER:IsOwner()
	return FSA_OwnerInDisguise( self ) or self:GetNetworkedInt("fsa_level", 5) == 0
end
function PLAYER:IsSuperAdmin()
	return FSA_SuperAdminInDisguise( self ) or self:GetNetworkedInt("fsa_level", 5) <= 1
end
function PLAYER:IsAdmin()
	return FSA_AdminInDisguise( self ) or self:GetNetworkedInt("fsa_level", 5) <= 2
end