Msg("\n-----------------\n[FSA][SH] Loading\n-----------------\n")
local FSA = {}
FSA.Plugins = {}
FSA.Ranks = {}
FSA.Ranks[0] = "Owner"
FSA.Ranks[1] = "Super Admin"
FSA.Ranks[2] = "Admin"
FSA.Ranks[3] = "Gold Member"
FSA.Ranks[4] = "VIP"
FSA.Ranks[5] = "Player"

function FSA_GetTable()
	return FSA
end
function FSA_GetConfig()
	return FSA.Config
end
function FSA_GetPlugins()
	return FSA.Plugins
end
function FSA_GetRanks()
	return FSA.Ranks
end
function FSA_SetPlugin( PluginData )
	table.insert( FSA.Plugins, PluginData )
	if SERVER then
		Msg("[FSA][SV] Loaded Core Plugin " .. PluginData.Name .. "\n")
	elseif CLIENT then
		Msg("[FSA][CL] Loaded Core Plugin " .. PluginData.Name .. "\n")
	end
end
include("fsa_coreplugins.lua")

local function FSA_OpenPlugins()
	local pluginsfolder = file.FindInLua("fsaplugins/*.lua")
	for int, file in ipairs(pluginsfolder) do
		include( "fsaplugins/"..file )
	end
end

function FSA_LoadPlugin( PluginData )
	if SERVER then
		if PluginData.Client then AddCSLuaFile("fsaplugins/"..PluginData.File) end
		if PluginData.Server then table.insert( FSA.Plugins, PluginData ) end
		Msg("[FSA][SV] Loaded Plugin " .. PluginData.Name .. "\n")
	elseif CLIENT then
		table.insert( FSA.Plugins, PluginData )
		Msg("[FSA][CL] Loaded Plugin " .. PluginData.Name .. "\n")
	end
end
FSA_OpenPlugins()

function FSA_plyByID( plyID )
	for k, ply in ipairs(player.GetAll()) do
		if ply:UniqueID() == plyID then
			return ply
		end
	end
end

local PLAYER = FindMetaTable("Player")
function PLAYER:FSA_CanAffect( affectplayer )
	if !affectplayer:IsPlayer() then return false end
	local affectlevel = affectplayer:FSA_Level()
	local inflictorlevel = 5
	if self:IsOwner() then
		inflictorlevel = 0
	elseif self:IsSuperAdmin() then
		inflictorlevel = 1
	elseif self:IsAdmin() then
		inflictorlevel = 2
	elseif self:IsGoldMember() then
		inflictorlevel = 3
	elseif self:IsVIP() then
		inflictorlevel = 4
	end
	--return self:GetNetworkedInt("fsa_level", 5) < affectplayer:GetNetworkedInt("fsa_level", 5)
	return inflictorlevel < affectlevel
end

function PLAYER:FSA_Level()
	return self:GetNetworkedInt("fsa_level", 5)
end

function PLAYER:GetLevel() --For OCRP
	return self:GetNetworkedInt("fsa_level", 5)
end

function PLAYER:FSA_LevelString()
	return FSA.Ranks[self:FSA_Level()] or "Unknown"
end

--Used to override admin checks.
function PLAYER:IsGoldMember() return self:GetNetworkedInt("fsa_level", 5) <= 3 end
function PLAYER:IsVIP() return self:GetNetworkedInt("fsa_level", 5) <= 4 end